<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
  "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html
  xmlns="http://www.w3.org/1999/xhtml"
  xmlns:xi="http://www.w3.org/2001/XInclude"
  xmlns:xc="urn:xhtml-compiler"
  xc:news="yes"
  xml:lang="en">
<head>
  <title>Switching to Git - News - HTML Purifier</title>
  <xi:include href="common-meta.xml" xpointer="xpointer(/*/node())" />
  <meta name="Date" content="Mon, 23 June 2008 22:42:00 EST" />
</head>
<body>

<xi:include href="common-header.xml" xpointer="xpointer(/*/node())" />

<div id="main">
<h1 id="title">Switching to Git</h1>

<div id="content">
  <p>
    After several weeks of testing, HTML Purifier is proud to announce that
    it will be switching to Git as its source control management system.
    Git offers a number of advantages over Subversion:
  </p>
  <ul>
    <li>
      <em>Superior support for branchy development.</em> Subversion 1.5 introduces
      merge-tracking which somewhat diminishes this benefit, but implementing
      that is entirely at the whimsy of Dreamhost, which I am not going to
      bother with.
    </li>
    <li>
      <em>Increased possibility for user participation.</em> Git makes it extremely
      easy to do local development and submit patches.
    </li>
    <li>
      <em>Data redundancy.</em> Every user has a complete copy of HTML Purifier's
      history, making it extremely difficult to lose data. This is opposed
      to our current setup, where htmlpurifier.org is a central point of failure,
      and backups are sent to only one other machine.
    </li>
    <li>
      <em>Performance.</em> Git is fast, both in terms of disk operations
      and network operations. Gone are the days of waiting several minutes
      for Subversion to finish committing.
    </li>
  </ul>
  <p>
    Currently, only <code>htmlpurifier</code> has been migrated to Git;
    <code>htmlpurifier-web</code> will be migrated after any kinks are
    worked out. There are number of features such as nightly snapshot
    generation and contributor documentation that needs to be written.
  </p>
  <p>
    We will be using <a href="http://repo.or.cz/w/htmlpurifier.git">repo.or.cz</a>
    as our primary remote repository; push access will be administered there,
    and changes will be mirrored (courtesy of a script by aeruder at #git) 
    to a repository hosted at <a href="http://git.htmlpurifier.org">git.htmlpurifier.org</a>
    as well as <a href="http://github.com/ezyang/htmlpurifier/tree/master">GitHub</a>.
    If you want to grab a development copy, use this command:
  </p>
  <pre>git clone git://repo.or.cz/htmlpurifier.git</pre>
  <p>
    Feel free to play around, and register comments and complaints at
    <a href="phorum">the forum</a>.
  </p>
</div>
</div>
</body>
</html>